=== modified file 'TODO'
--- TODO	2007-03-23 13:41:56 +0000
+++ TODO	2007-07-07 22:02:45 +0000
@@ -15,3 +15,7 @@
 - Ability to bind/unbind the branch
 - List Bzr options in context menu in a way that makes sense (alphabetically?)
 - Allow specifying two revisions in the diff window rather then always diffing between base and working tree
+- For performance BranchDialog should only open each url once. Once opened it
+  should keep a read lock open and only release this when the url is changed.
+  It should also allow the creator of the window to supply an already opened
+  branch, and a revision id.

=== modified file '__init__.py'
--- __init__.py	2007-07-05 05:01:53 +0000
+++ __init__.py	2007-07-07 22:02:45 +0000
@@ -528,7 +528,13 @@
                     """Start the viz program."""
                     pp = start_viz_window(branch, revision_id)
                     pp.show()
+                def start_branch(notification=None, action=None, data=None):
+                    """Start a Branch dialog"""
+                    from bzrlib.plugins.gtk.branch import BranchDialog
+                    bd = BranchDialog(remote_path=url)
+                    bd.run()
                 nw.add_action("clicked", "Inspect", start_viz, None)
+                nw.add_action("clicked", "Branch", start_branch, None)
                 nw.set_timeout(5000)
                 nw.show()
             except Exception, e:

=== modified file 'branch.py'
--- branch.py	2007-05-17 16:12:27 +0000
+++ branch.py	2007-07-07 22:02:45 +0000
@@ -37,6 +37,7 @@
 
 class BranchDialog(gtk.Dialog):
     """ New implementation of the Branch dialog. """
+
     def __init__(self, path=None, parent=None, remote_path=None):
         """ Initialize the Branch dialog. """
         gtk.Dialog.__init__(self, title="Branch - Olive",

